<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

$template->set_filenames(array('plugins' => PLUGINSMANAGER_PATH . 'template/plugins_list.tpl'));

//--------------------------------------------------perform requested actions
if (isset($_GET['action']) and isset($_GET['plugin']) and !is_adviser())
{
  $page['errors'] = $plugins->perform_action($_GET['action'], $_GET['plugin']);

  if (empty($page['errors'])) redirect($base_url);
}

//---------------------------------------------------------------Order options
$order = explode(',', $conf['PluginsManager']);
if (isset($_GET['order']))
{
	$order[0] = $_GET['order'];
	$query = 'UPDATE ' . CONFIG_TABLE . '
SET value="' . implode(',', $order) . '"
WHERE param="PluginsManager"
LIMIT 1';
    pwg_query($query);
}
$orders = array('name' => l10n('Name'),
				'status' => l10n('Status'),
        'author' => l10n('Author'),
        'id' => 'Id');
				
foreach ($orders as $key => $value)
{
    $template->assign_block_vars(
      'order',
        array(
          'DISPLAY' => $value,
          'URL' => htmlentities($base_url) . '&amp;order=' . $key,
          'SELECTED_OPTION' => ($order[0] == $key ? 'SELECTED' : '')));
}

// +-----------------------------------------------------------------------+
// |                     start template output                             |
// +-----------------------------------------------------------------------+
$plugins->sort_fs_plugins($order[0]);

$num = 0;
foreach($plugins->fs_plugins as $plugin_id => $fs_plugin) {
    $display_name = $fs_plugin['name'];
    if (!empty($fs_plugin['uri'])) {
        $display_name = '<a href="' . $fs_plugin['uri'] . '" onclick="window.open(this.href); return false;">' . $display_name . '</a>';
    }
    $desc = $fs_plugin['description'];
    if (!empty($fs_plugin['author'])) {
        $desc .= ' (<em>';
        if (!empty($fs_plugin['author uri'])) {
            $desc .= '<a href="' . $fs_plugin['author uri'] . '">' . $fs_plugin['author'] . '</a>';
        } else {
            $desc .= $fs_plugin['author'];
        }
        $desc .= '</em>)';
    }
    $template->assign_block_vars('plugins.plugin',
        array('NAME' => $display_name,
            'VERSION' => $fs_plugin['version'],
            'DESCRIPTION' => $desc,
            'CLASS' => (isset($plugins->db_plugins_by_id[$plugin_id]) ? $plugins->db_plugins_by_id[$plugin_id]['state'] . '_' : '')
                        . (($num++ % 2 == 1) ? 'row2' : 'row1'),
            )
        );

	$action_url = htmlentities($base_url) . '&amp;plugin=' . $plugin_id;

    if (isset($plugins->db_plugins_by_id[$plugin_id])) { 
        switch ($plugins->db_plugins_by_id[$plugin_id]['state']) {
            case 'active':
                $template->assign_block_vars('plugins.plugin.action',
                    array('U_ACTION' => $action_url . '&amp;action=deactivate',
                        'L_ACTION' => l10n('Deactivate'),
                        )
                    );
                break;
            case 'inactive':
                $template->assign_block_vars('plugins.plugin.action',
                    array('U_ACTION' => $action_url . '&amp;action=activate',
                        'L_ACTION' => l10n('Activate'),
                        )
                    );
                $template->assign_block_vars('plugins.plugin.action',
                    array('U_ACTION' => $action_url . '&amp;action=uninstall',
                        'L_ACTION' => l10n('Uninstall'),
                        )
                    );
                $template->assign_block_vars('plugins.plugin.action.confirm', array('CONFIRM' => l10n('pm_confirm'), ENT_QUOTES));
                break;
        }
    } else {
        $template->assign_block_vars('plugins.plugin.action',
            array('U_ACTION' => $action_url . '&amp;action=install',
                'L_ACTION' => l10n('Install'),
                )
            );
        $template->assign_block_vars('plugins.plugin.action.confirm', array('CONFIRM' => l10n('pm_confirm'), ENT_QUOTES));
		
		$template->assign_block_vars('plugins.plugin.action',
            array('U_ACTION' => $action_url . '&amp;action=delete',
                'L_ACTION' => l10n('pm_delete'),
                )
            );
        $template->assign_block_vars('plugins.plugin.action.confirm', array('CONFIRM' => l10n('pm_confirm_delete')));
    }
}

$missing_plugin_ids = array_diff(
    array_keys($plugins->db_plugins_by_id), array_keys($plugins->fs_plugins)
    );
foreach($missing_plugin_ids as $plugin_id) {
    $template->assign_block_vars('plugins.plugin',
        array('NAME' => $plugin_id,
            'VERSION' => $db_plugins_by_id[$plugin_id]['version'],
            'DESCRIPTION' => "ERROR: THIS PLUGIN IS MISSING BUT IT IS INSTALLED! UNINSTALL IT NOW !",
            'CLASS' => ($num++ % 2 == 1) ? 'row2' : 'row1',
            )
        );
    $action_url = htmlentities($base_url) . '&amp;plugin=' . $plugin_id;
    $template->assign_block_vars('plugins.plugin.action',
        array('U_ACTION' => $action_url . '&amp;action=uninstall',
            'L_ACTION' => l10n('Uninstall'),
            )
        );
}
?>